/// <reference types="node" />
import { Application, Configuration, Facility, Middleware, MiddlewareFunction, PlumierApplication, PlumierConfiguration } from "@plumier/core";
import Koa from "koa";
export declare class Plumier implements PlumierApplication {
    readonly config: Readonly<PlumierConfiguration>;
    readonly koa: Koa;
    constructor();
    use(middleware: string | symbol | MiddlewareFunction | Middleware, scope?: "Global" | "Action"): Application;
    set(facility: Facility): Application;
    set(config: Partial<Configuration>): Application;
    initialize(): Promise<Koa>;
    listen(port?: number | string): Promise<import("http").Server<typeof import("http").IncomingMessage, typeof import("http").ServerResponse>>;
}
